using System.Security.Cryptography;
using System.IO;
using System;
using System.Text;

public class Cifra3des
  {

  public static void Main(string[] Args)
    {

    // Obtenemos un provider 3DES
    
    TripleDES td = TripleDES.Create();
    
    // Tomamos el mensaje a cifrar
    
    System.Console.Write("Escriba su mensaje a cifrar: ");
    string mensaje=System.Console.ReadLine();

    // Generamos una nueva llave y un vector de inicializacin

    td.GenerateKey();
    td.GenerateIV();

    // Convertimos la cadena a ristra de bytes

    byte[] bytemen = Encoding.ASCII.GetBytes(mensaje);
    
    // Abrimos un stream de memoria con escribiremos el cifrado

    MemoryStream mem = new MemoryStream();

    // Iniciamos un cryptostream que lo enlazamos al stream de memoria

    CryptoStream cs = new CryptoStream(mem,td.CreateEncryptor(),CryptoStreamMode.Write);
   
    // Escribimos en el criptostream el mensaje convertido a bytes

    cs.Write(bytemen,0,bytemen.Length);
    cs.FlushFinalBlock();

    // Obtenemos el resultado del stream de memoria

    byte[] encrypted = mem.ToArray();

    mem.Seek(0,SeekOrigin.Begin);
    StreamReader reader1 = new StreamReader(mem);
    System.Console.WriteLine("Texto Cifrado: "+reader1.ReadToEnd());

    // Creamos un nuevo stream de memoria del que leeremos el descifrado

    MemoryStream mem2 = new MemoryStream();

    // Inciamos un cryptostream para descifrar

    CryptoStream cs2 = new CryptoStream(mem2,td.CreateDecryptor(),CryptoStreamMode.Write);
   
    // Escribimos el texto cifrado y sale descifrado al stream de memoria

    cs2.Write(encrypted,0,encrypted.Length);
    cs2.FlushFinalBlock();

    // Obtenemos el texto descifrado

    mem2.Seek(0,SeekOrigin.Begin);
    StreamReader reader = new StreamReader(mem2);
    System.Console.WriteLine("Texto Descifrado: "+reader.ReadToEnd());

    }
  }
