using System;
using System.Security.Cryptography;
using System.IO;
using System.Text;

public class HashExample
  {

  public static void Main(string[] args)
    {
    
    if(args.Length==0)
      {
      System.Console.WriteLine("\n  Uso: ejemploSHA512.exe fichero\n\n");
      System.Environment.Exit(0);

      }
    

    StreamReader sr = new StreamReader(args[0]);

    string mensaje = sr.ReadToEnd();
    
    byte[] mensajeBytes = Encoding.ASCII.GetBytes(mensaje);

    SHA512 sha = SHA512.Create();

    byte[] hash = sha.ComputeHash(mensajeBytes);
    
    System.Console.WriteLine("Hash:"+BitConverter.ToString(hash));

    }


  }
